import pygame
from Button import Button
from Loader import Loader
from StaticText import StaticText

class ComboButton(Button):
	def __init__(self,x,y,w,icon,label,callback):
		self.icon = Loader().load_art(icon)[0]
		self.labels = []
		_y = y
		y = 3
		h = self.icon.get_size()[1]+6
		for str in label.split("\n"):
			txt = StaticText(self.icon.get_size()[0]+6,y,str,(196,196,196),16)
			self.labels.append(txt)
			y += txt.size[1]
		self.surface = pygame.surface.Surface((w,h))
		self.surface.blit(self.icon,(3,3))
		for lbl in self.labels:
			lbl.draw(self.surface)
		Button.__init__(self,x,_y,callback)
		self.size = [w,h]
		self.rect = pygame.Rect(self.x,self.y,w,h)