from Button import Button
from Loader import Loader
import pygame

class IconButton(Button):
	def __init__(self,x,y,icon,callback,label=None,position="left"):
		self.surface = Loader().load_art(icon)[0]
		self.surface.set_colorkey((0,0,0))
		Button.__init__(self,x,y,callback)
		self.label = None
		self.label_pos = None
		if label != None:
			self.label = Loader().load_font("slkscr",16).render(label,False,self.active_color)
			size = self.label.get_size()
			if position == "left":
				self.label_pos = (x-size[0]-5,y+self.size[1]/2-size[1]/2)
			elif position == "right":
				self.label_pos = (x+size[0],y+self.size[1]/2-size[1]/2)
			elif position == "bottom":
				self.label_pos = (x+self.size[0]/2-size[0]/2,y+size[1]+1)	
			elif position == "top":
				self.label_pos = (x+self.size[0]/2-size[0]/2,y-size[1]-1)	