class EntityManager:
	def __init__(self):
		self.objects = []
	
	def children(self):
		return self.objects
	
	def add(self,obj):
		self.objects.append(obj)
	
	def remove(self,obj):
		self.objects.remove(obj)
		
	def update(self):
		for obj in self.objects:
			obj.update()
		
	def clear(self):
		self.objects = []
	
	def size(self):
		return len(self.objects)
	
	def draw(self,surface):
		for obj in self.objects:
			obj.draw(surface)