from random import *

# map tiles are tuples, of the form:
# ( sprite_index, reveal_number0-3 )
def generate(width,height,start=(9,39)):
	map = []
	for i in range(0,height):
		row = []
		for j in range(0,width):
			row.append([0,-1])
		map.append(row)
	specials = {}
	specials['money'] = []
	specials['fuel'] = []
	map = fork_tunnel(map,start[0],start[1],10,specials)[0]
	for point in specials['money']:
		map[point[1]][point[0]][0] = 1
	map[specials['up'][1]][specials['up'][0]][0] = 1
	map[specials['down'][1]][specials['down'][0]][0] = 1
	return (map,specials)

def fork_tunnel(map,x,y,forks_left,specials,c=0):
	if forks_left <= 0:
		return (map,c)
	pos = [x,y]
	prev = None
	has_forked = False
	for i in range(0,100):
		c += 1
		if pos[1] in range(0,len(map)) and pos[0] in range(0,len(map[0])):
			map[pos[1]][pos[0]][0] = 1
			if c == 32:
				specials['down'] = (pos[0],pos[1])
			elif c == 12:
				specials['up'] = (pos[0],pos[1])
			elif i == 80:
				specials['money'].append((pos[0],pos[1]))
			elif i > 33 and random() < 0.002:
				specials['fuel'].append((pos[0],pos[1]))
		else:
			return (map,c)
		if random() < 0.1 and forks_left > 0 and not has_forked:
			pair = fork_tunnel(map,pos[0],pos[1],forks_left-1,specials,c)
			c += pair[1]
			map = pair[0]
			has_forked = True
		tunnel = randint(0,5)
		while tunnel == prev:
			tunnel = randint(0,5)
		if tunnel == 0:
			pos[1]-=2
		elif tunnel == 1:
			pos[1] -= 1
			if pos[1] % 2 == 0:
				pos[0] += 1
		elif tunnel == 2:
			pos[1] += 1
			if pos[1] %2 == 0:
				pos[0] += 1
		elif tunnel == 3:
			pos[1] += 2
		elif tunnel == 4:
			pos[1] += 1
			if pos[1] %2 == 1:
				pos[0] -= 1
		elif tunnel == 5:
			pos[1] -= 1
			if pos[1] % 2 == 1:
				pos[0] -= 1
	return (map,c)