import pygame
from State import State
from Entity import Entity
from Tile import *

class Player(Entity):
	def __init__(self,map,coords):
		Entity.__init__(self,"@",(128,0,0),map,coords)
		self.reveal(1)
	
	def move(self,dir):
		self.reveal(2)
		ret = Entity.move(self,dir)
		self.reveal(1)
		if ret:
			self.state.fuel -= 0.5
		return ret