from EntityManager import EntityManager

class GuiManager(EntityManager):
	def __init__(self):
		EntityManager.__init__(self)
		self.last_clicked = None

	def mouseover(self,x,y):
		for widget in self.children():
			if widget.mouseover(x,y):
				return widget
		return False
	
	def get_last_clicked(self):
		return self.last_clicked
	
	def click(self,x,y):
		for widget in self.children():
			if widget.mouseover(x,y):
				self.last_clicked = widget
				widget.click(x,y)
				return widget
		return False
		