from Button import Button
from Loader import Loader
import pygame

class TextButton(Button):
	def __init__(self,x,y,label,callback):
		lbl = Loader().load_font("slkscr",16).render(label,False,self.active_color)
		size = lbl.get_size()
		self.surface = pygame.surface.Surface( (size[0]+8,size[1]+4) )
		self.surface.fill( (0,0,0) )
		self.surface.blit(lbl,(4,2))
		Button.__init__(self,x,y,callback)
	
	def click(self,x,y):
		return Button.click(self,x,y)